import tensorflow as tf
import keras
from keras.models import Sequential
from keras.layers import Activation, Dropout
from keras.layers.core import Dense
from keras.optimizers import Adam
from keras.utils import np_utils
from sklearn import preprocessing
from sklearn.metrics import confusion_matrix
import numpy as np 
from random import randint
import csv



#------------------DATA PRE-PROCESSING------------------
# Database vectors
train_labels = []
# Label of each gesture
train_samples = []



# Open database and divide each sample into input data and label
with open('databaseletras.txt', 'r') as csvfile:
		spamreader = csv.reader(csvfile, delimiter=' ', quotechar='|')
		for row in spamreader:
				newRow = row[0].split(',')
				train_labels.append(newRow.pop(12))
				train_samples.append(list(map(float, newRow)))

# Converting data into np.array
train_samples = np.array(train_samples)
train_labels = np.array(train_labels)

# Convert labels vector into a binary matrix.
lb = preprocessing.LabelBinarizer()
lb.fit(train_labels)
bin_labels  = lb.transform(train_labels)

# Normalize input data
normalize_samples = keras.utils.normalize(train_samples, axis=-1, order=2)


#------------------NETWORK ARCHITECTURE------------------

# Create model of the network
def baseline_model():
	model = Sequential()
	model.add(Dense(128, input_dim=12, activation='relu'))
	model.add(Dropout(0.25))
	model.add(Dense(64, activation='relu'))
	model.add(Dropout(0.25))
	model.add(Dense(32, activation='relu'))
	model.add(Dropout(0.25))
	model.add(Dense(17, activation='softmax'))
	model.compile(Adam(lr=.0001), loss='binary_crossentropy', metrics=['accuracy'])
	return model


# Training model, it can take long time
model = baseline_model()
model.fit(normalize_samples, bin_labels, validation_split = 0.1, batch_size=5, epochs=10, shuffle=True, verbose=2)

# Saving model for later use
print("Saving model, weights and optimizer to disk")
# Change name if you don't want to overwritte
model.save('Prueba1.h5')
print("Model saved")