import tensorflow as tf
import keras
from keras.utils import np_utils
from keras.models import Sequential
from keras.layers import Dense
from keras.models import load_model
from sklearn import preprocessing
import numpy as np
import os
import csv


retrain_labels = []
retrain_samples = []

#Open file to predict
with open('retrain.txt', 'r') as csvfile:
		spamreader = csv.reader(csvfile, delimiter=' ', quotechar='|')
		for row in spamreader:
				newRow = row[0].split(',')
				retrain_labels.append(newRow.pop(12))
				retrain_samples.append(list(map(float, newRow)))


retrain_samples = np.array(retrain_samples)
retrain_labels = np.array(retrain_labels)

#Encoding labels to binary matrix
lb = preprocessing.LabelBinarizer()
lb.fit(['A','B','C','D','E','F','G','H','I','K','L','P','T','U','V','W','Y'])

normalize_samples = keras.utils.normalize(retrain_samples, axis=-1, order=2)


bintest_labels = lb.transform(retrain_labels)

#Load old model from disk
model = load_model('sign_language_NN.h5')
print("Model loaded from disk")

print("Re-training model")
model.fit(normalize_samples, bintest_labels, validation_split = 0.1, batch_size=5, epochs=10, shuffle=True, verbose=2)

#Saving new retrained model into disk
print("Saving model, weights and optimizer to disk")
#For overwrite the net savefile do not change this name. For creating a new one, change it.
model.save('sign_language.h5')
print("Model saved")




